import javax.swing.*;
import java.util.*;
import java.io.*;
import java.lang.*;
import java.awt.event.*;
import java.awt.*;
 

class Punkt
{ protected int x, y;
   
  public Punkt(int wspX, int wspY) 
     {x = wspX; y = wspY;}
  
  public int podajX()  
   { return x;}
  
  public int podajY()  
   { return y;}  
  
  public int podajDl()       
   {return 5;}
  
  public double odleglosc(Punkt p)
   { return Math.sqrt((x-p.x)*(x-p.x)+(y-p.y)*(y-p.y)); }
 
  public void rysuj(Graphics g)
    {  Graphics2D g2D= (Graphics2D)g;
       Color pedzel =new Color(255,0,0);
       g2D.setColor(pedzel);
       g2D.fillOval(x,y,5,5);
     } 
  
  public void przesun(int dx, int dy, int a, int b)
   {x+=dx; y+=dy; 
    if (x>a || x<1) x=5;
    if (y>b || y<1) y=2;
   } 
  }

class Kwadrat extends Punkt
{ protected int dlugosc;

  public Kwadrat(int wspX, int wspY,int dl)
   { super(wspX,wspY);
     dlugosc=dl;}
  
   public int podajDl()       
   {return dlugosc;}

  public void przesun(int dx, int dy, int a, int b)
    { super.przesun(dx,dy, a, b); //przesuwanie
      dlugosc+=dx+dy;             //i skalowanie
      if (dlugosc > 30 || dlugosc <10) dlugosc=20;
   	}

  public void rysuj(Graphics g)
    {Graphics2D g2D=(Graphics2D)g;
     Color pedzel=new Color(0,255,0);
     g2D.setColor(pedzel);
     g2D.fillRect(x,y,dlugosc,dlugosc);
    } 
 }
 

class Figury extends JPanel implements KeyListener, MouseListener
{ protected int N=6;
  protected int ile=0;
  protected int biezacy=0; //biezacy numer figury
  protected Punkt figury[]=new Punkt[N];
 
  
 public void Dodaj_punkt()
  { if(ile<figury.length)
       figury[ile++]=new Punkt(ile*22,ile*22);
  }
  
 public void Dodaj_kwadrat()
  { if(ile<figury.length)
       figury[ile++]=new Kwadrat(ile*44,ile*44,ile+44);
  }
  
/***obsluga zdarzen przez sluchacza zdarzen MouseListener***/
public void mouseClicked(MouseEvent e) 
 // Invoked when the mouse button has been clicked (pressed and released) on a component. 
 {int x_=e.getX();
  int y_=e.getY();
  for (int i=0; i<ile;i++)
   if (figury[i].podajX()+figury[i].podajDl()>=x_ && 
       figury[i].podajX()<=x_&&
       figury[i].podajY()+figury[i].podajDl()>=y_&&
       figury[i].podajY()<=y_)
        { biezacy=i;
          System.out.println(biezacy); 
          break;}
    requestFocus();//przywrocenie zdolnosci do obslugi zdarzen od klawiatury
    repaint();
  }
 
 public void mouseEntered(MouseEvent e) 
 //Invoked when the mouse enters a component. 
  { }
 
 public void mouseExited(MouseEvent e) 
 //Invoked when the mouse exits a component. 
  { }
 
 public void mousePressed(MouseEvent e) 
 //Invoked when a mouse button has been pressed on a component. 
  { }
 
 public void mouseReleased(MouseEvent e) 
 //Invoked when a mouse button has been released on a component. 
  { }
  
/***obsluga zdarzen przez sluchacza zdarzen  KeyListener ***/
 public void keyPressed (KeyEvent evt)
 //Virtual keys (arrow keys, function keys, etc) - handled with keyPressed() listener. 
  { if(ile==0) return;
    int dx=0, dy=0, zmiana;
    Random r=new Random();
    if (evt.isShiftDown())  
     zmiana = r.nextInt(100);
    else 
     zmiana =r.nextInt(10);
    switch (evt.getKeyCode()) 
     {  case KeyEvent.VK_LEFT : dx -=  zmiana;   break;
        case KeyEvent.VK_RIGHT: dx +=  zmiana;   break;
        case KeyEvent.VK_UP   : dy -=  zmiana;   break;
        case KeyEvent.VK_DOWN : dy +=  zmiana;   break;       
     }
    figury[biezacy].przesun(dx,dy, getWidth(), getHeight()); 
    repaint(); //odswiezenie widoku okna
  }
 
 public void keyReleased (KeyEvent evt)
  {  } 

 public void keyTyped (KeyEvent evt)
 //Characters (a, A, #, ...) - handled in the keyTyped() listener. 
 { char znak=evt.getKeyChar(); //reakcja na nacisniecie klawisza
   int pom=(int)znak-48; //wybr figury
   if ( pom>=0&& pom<ile)
    biezacy=pom;
   else
    biezacy=0; 
  System.out.println(biezacy);  
 }   
 
 public void paintComponent(Graphics g) //przedefiniowanie metody  klasy JPanel
 	 { super.paintComponent(g);// teraz figury nie zostawiaja sladu przy przesuwaniu, 
 	   //metoda konieczna do prawidlowego wyswietlania przyciskw
 	   for (int i=0; i<ile; i++)   
         figury[i].rysuj(g); }  //automatyczne rysowanie albo punktu albo kwadratu 
 }

public class Obraz6_3 extends JFrame
                      implements ActionListener
{
protected JButton punkt=new JButton ("Punkt");
protected JButton kwadrat = new JButton("Kwadrat");
protected Figury rysunek;

public  Obraz6_3 () 
{super ("Obraz6_3");
 setSize(400,400);   
 setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
 rysunek=new Figury();
 rysunek.setLayout(new FlowLayout());
 rysunek.addKeyListener(rysunek);
 rysunek.setFocusable(true);   
 rysunek.addMouseListener(rysunek);
 punkt.addActionListener(this);
 kwadrat.addActionListener(this);
 rysunek.add(punkt);
 rysunek.add(kwadrat); 
 setContentPane(rysunek);
 setVisible(true); 

}
 
public void actionPerformed (ActionEvent evt)
{
 Object zrodlo = evt.getSource();
 if(zrodlo==punkt)
   rysunek.Dodaj_punkt();
  else if(zrodlo==kwadrat)
    rysunek.Dodaj_kwadrat();
  rysunek.requestFocus(); //przywrocenie zdolnosci do obslugi zadarzen pd klawiatury
  repaint();
}

public static void main(String args[])
  { Obraz6_3 obraz=new Obraz6_3();}

}
 



